#!/bin/bash

armcap=0

lscpu | grep "Flags" | grep -q "neon" && armcap=$((armcap | (1 << 0)))
lscpu | grep "Flags" | grep -q "aes" && armcap=$((armcap | (1 << 2)))
lscpu | grep "Flags" | grep -q "sha1" && armcap=$((armcap | (1 << 3)))
lscpu | grep "Flags" | grep -q "sha2" && armcap=$((armcap | (1 << 4)))
lscpu | grep "Flags" | grep -q "pmull" && armcap=$((armcap | (1 << 5)))
lscpu | grep "Flags" | grep -q "sha512" && armcap=$((armcap | (1 << 6)))
lscpu | grep "Flags" | grep -q "cpuid" && armcap=$((armcap | (1 << 7)))
lscpu | grep "Flags" | grep -q "rng" && armcap=$((armcap | (1 << 8)))
lscpu | grep "Flags" | grep -q "sm3" && armcap=$((armcap | (1 << 9)))
lscpu | grep "Flags" | grep -q "sm4" && armcap=$((armcap | (1 << 10)))
if lscpu | grep "Flags" | grep -q "sha3"; then
	armcap=$((armcap | (1 << 11)))
	cat /proc/cpuinfo | grep "CPU part" | grep -q "0xd40" && armcap=$((armcap | (1 << 12)))
	cat /proc/cpuinfo | grep "CPU part" | grep -q "0xd49" && armcap=$((armcap | (1 << 12)))
	cat /proc/cpuinfo | grep "CPU part" | grep -q "0xd4f" && armcap=$((armcap | (1 << 12)))
	cat /proc/cpuinfo | grep "CPU part" | grep -q "0xd40" && armcap=$((armcap | (1 << 16)))
	cat /proc/cpuinfo | grep "CPU part" | grep -q "0xd4f" && armcap=$((armcap | (1 << 16)))
fi
lscpu | grep "Flags" | grep -q "sve" && armcap=$((armcap | (1 << 13)))
lscpu | grep "Flags" | grep -q "sve2" && armcap=$((armcap | (1 << 14)))

# Disable CE instruction set features, i.e. bits 2 (AES), 0 (NEON). 16 (UNROLL12_EOR3), 12 (UNROLL8_EOR3),
# 5 (PMULL), 3 (SHA1), 4 (SHA256), 6 (SHA512), 15 (SHA3_AND_WORTH_USING) and 11 (SHA3)
disable_mask=$((0x58 | 0x11025 | 0x8801))
armcap=$((armcap & ~disable_mask))

export OPENSSL_armcap=$armcap
